<?php
//CB Advanced Search Component//
/**
* Front End Code
*@package cbadancedsearch
*@Copyright (C) 2006 Emptorum.com
*@ ALl Rights reserved
*@license  http://www.gnu.org/copyleft/gpl.html. GNU Public License
*@version 1.0
*/


defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );

/**
* @package GSG
* @subpackage Config
* Functions taken from the com_config
*/
class cbsaConfig {
   // Site Settings
   /** @var int */
   var $cbsa_logical = 0;
   /** @var int */
   var $cbsa_comparision = 0; 
   /** @var int */
   var $cbsa_allow_adv_search = 0; 
   /** @var int */
   var $cbsa_allow_search_1 = 0;
   /** @var int */
   var $cbsa_allow_search_2 = 0;
   /** @var int */
   var $cbsa_page_nav = 0;
   /** @var int */
   var $cbsa_logical_default = 0;   
   /** @var int */
   var $cbsa_logical_equal = 0;
   /** @var int */
   var $cbsa_logical_or = 0;
   /** @var int */
   var $cbsa_logical_not = 0;
   /** @var int */
   var $cbsa_logical_and = 0;
   /** @var int */
   var $cbsa_show_result = 0;
   /** @var int */
   var $cbsa_show_title = 0;
   /** @var int */
   var $cbsa_show_sql_error = 0;
   /** @var int */
   var $cbsa_deactivate_allowaccess = 0;

   /**
    * @return array An array of the public vars in the class
    */
   function getPublicVars() {
      $public = array ();
      $vars = array_keys(get_class_vars(get_class($this)));
      sort($vars);
      foreach ($vars as $v) {
         if ($v {
            0 }
         != '_') {
            $public[] = $v;
         }
      }
      return $public;
   }

   /**
    * binds a named array/hash to this object
    * @param array $hash named array
    * @return null|string  null is operation was satisfactory, otherwise returns an error
    */
   function bind($array, $ignore = '') {
      if (!is_array($array)) {
         $this->_error = strtolower(get_class($this)).'::bind failed.';
         return false;
      } else {
         return mosBindArrayToObject($array, $this, $ignore);
      }
   }

   /**
    * Writes the configuration file line for a particular variable
    * @return string
    */
   function getVarText() {
      $txt = '';
      $vars = $this->getPublicVars();
      foreach ($vars as $v) {
         $k = str_replace('config_', 'mosConfig_', $v);
         $txt .= "\$$k = '".addslashes($this-> $v)."';\n";
      }
      return $txt;
   }

   /**
    * Binds the global configuration variables to the class properties
    */
   function bindGlobals() {
      $vars = $this->getPublicVars();
      foreach ($vars as $v) {
         $k = str_replace('config_', 'mosConfig_', $v);
         if (isset ($GLOBALS[$k]))
            $this-> $v = $GLOBALS[$k];
      }
   }

}

/**
*
* Class for the table #__cb_search
*/

class cbs_table extends mosDBTable {
   // Site Settings
   /** @var int */
   var $id = null;
   /** @var varchr */
   var $name = null;
   /** @var tinyint */
   var $default = null;
   /** @var tinyint */
   var $published = null;
   /** @var varchr */
   var $sql_code = null;
   /** @var int */
   var $ordering = null;
   /** @var int */
   var $category = null;
   

   function cbs_table(& $db) {
      $this->mosDBTable('#__cb_search', 'id', $db);
   }
}


/**
*
* Class for the table #__cb_search_fields
*/

class cbs_fields extends mosDBTable {
   // Site Settings
   /** @var int */
   var $id = null;
   /** @var varchr */
   var $fieldid = null;
   /** @var tinyint */
   var $search = null;
   /** @var int */
   var $ordering = null;

   function cbs_fields ($db) {
      $this->mosDBTable('#__cb_search_fields', 'id', $db);
   }
}


class cb_as {
/**   @var int 1=Front End 2=Admin */
var $ui=0;
/** @var string Date Format */
var $dateFormat;

function getFieldEntry($ui,&$calendars,$oType,$oName,$oDescription,$oTitle,$oValue,$oReq,$oLabel,$oID,$oSize, $oMaxLen, $oCols, $oRows,$oProfile, $rowFieldValues=null,$oReadOnly=0) {
global $ueConfig,$database,$mosConfig_live_site;
   $oReturn = '';
   
      if($oSize > 0) $pSize=" size='".$oSize."' ";
      else $pSize="";
      if($oMaxLen > 0) $pMax=" maxlength='".$oMaxLen."' ";  
      else $pMax="";
      if($oCols > 0) $pCols=" cols='".$oCols."' "; 
      else $pCols="";
      if($oRows > 0) $pRows=" rows='".$oRows."' "; 
      else $pRows="";
      if($oReadOnly > 0) { 
         $pReadOnly=" disabled=\"disabled\" ";
         $oReq=0;
      } else { 
         $pReadOnly="";
      }
      $displayFieldIcons = false;
      SWITCH ($oType){
         CASE 'predefined':
         CASE 'text':
            $oReturn = "<input class=\"inputbox\" $pReadOnly mosReq=".$oReq." mosLabel=\"".getLangDefinition($oLabel)."\" $pSize $pMax type=\"text\" name=\"".$oName."\" value=\"".$oValue."\" />";
         break;
         CASE 'textarea':
            $oReturn = "<textarea class=\"inputbox\" $pReadOnly mosReq=".$oReq." $pMax mosLabel=\"".getLangDefinition($oLabel)."\" $pCols $pRows  name=\"".$oName."\">".$oValue."</textarea>";
         break;
         CASE 'editorta':
            $oReturn = "<input class=\"inputbox\" $pReadOnly mosReq=".$oReq." mosLabel=\"".getLangDefinition($oLabel)."\" $pSize $pMax type=\"text\" name=\"".$oName."\" value=\"".$oValue."\" />";
         //Old settings
         // ob_start();
         // editorArea( 'editor'.$oName ,  $oValue , $oName , 500, 350, $oCols, $oRows ) ;
         // $oReturn=ob_get_contents();
         // ob_end_clean();
         // $oReturn .= ' <script type="text/javascript"> document.adminForm.'.$oName.".setAttribute('mosReq',".$oReq."); document.adminForm.".$oName.".setAttribute('mosLabel','".getLangDefinition($oLabel)."'); </script>";
         break;
         CASE 'select':
         CASE 'multiselect':
         CASE 'radio':
         CASE 'multicheckbox':
            $oReturn = $rowFieldValues;
         break;
         CASE 'checkbox':
            $checked='';
            if($oValue!='' && $oValue != null && $oValue==1) $checked=" checked=\"checked\"";
            $oReturn = "<input class=\"inputbox\" $pReadOnly mosReq=".$oReq." mosLabel=\"".getLangDefinition($oLabel)."\" type=\"checkbox\" $checked name=\"".$oName."\" value=\"1\" />";    
         break;
         CASE 'hidden':
            $oReturn = "<input class=\"inputbox\" $pReadOnly mosLabel=\"".getLangDefinition($oLabel)."\" type=\"hidden\" name=\"".$oName."\" value=\"".$oValue."\" />";
         break;
         CASE 'password':
            $oReturn = "<input class=\"inputbox\" $pReadOnly mosReq=".$oReq." mosLabel=\"".getLangDefinition($oLabel)."\" type=\"password\" name=\"".$oName."\" value=\"".$oValue."\" />";
         break;
         CASE 'date':
            $oReturn = cb_as::cbAddCalendar($oName,$oLabel,$oReq,$oValue,$oReadOnly);
         break;
         CASE 'primaryemailaddress':
         CASE 'emailaddress':
            $oReturn = "<input class=\"inputbox\" $pReadOnly $pMax mosReq=".$oReq." $pSize mosLabel=\"".getLangDefinition($oLabel)."\" type=\"text\" name=\"".$oName."\" id=\"".$oName."\" value=\"".$oValue."\" />";
         break;
         CASE 'webaddress':
            if ($oRows!=2) {
               $oReturn = "<input class=\"inputbox\" $pReadOnly $pMax $pSize mosReq=".$oReq." mosLabel=\"".getLangDefinition($oLabel)."\" type=\"text\" name=\"".$oName."\" id=\"".$oName."\" value=\"".$oValue."\" />";
            } else {
               $oValuesArr=array();
               $oValuesArr = explode("|*|",$oValue);
               if (count($oValuesArr) < 2) $oValuesArr[1]="";
               $oReturn = "<span class=\"webUrlSpan\">";
               $oReturn .= "<span class=\"subTitleSpan\">"._UE_WEBURL.":</span>";
               $oReturn .= "<span class=\"subFieldSpan\"><input class=\"inputbox\" $pReadOnly $pMax $pSize mosReq=".$oReq." mosLabel=\"".getLangDefinition($oLabel)."\" type=\"text\" name=\"".$oName."\" id=\"".$oName."\" value=\"".$oValuesArr[0]."\" />";
               $oReturn .= getFieldIcons($ui, $oReq, $oProfile, $oDescription, $oTitle)."</span>";
               $displayFieldIcons = false;
               
               $oReturn .= "</span><span class=\"webTextSpan\">";
               $oReturn .= "<span class=\"subTitleSpan\">"._UE_WEBTEXT.":</span>";
               $oReturn .= "<span class=\"subFieldSpan\"><input class=\"inputbox\" $pReadOnly $pMax $pSize mosReq=".$oReq." mosLabel=\"".getLangDefinition($oLabel)."\" type=\"text\" name=\"".$oName."Text\" id=\"".$oName."Text\" value=\"".$oValuesArr[1]."\" /></span>";
               $oReturn .= "</span>";
            }        
            break;
         CASE 'delimiter':
            $oReturn = '';
      
      }
      if ($oReturn and $displayFieldIcons) $oReturn .= getFieldIcons($ui, $oReq, $oProfile, $oDescription, $oTitle);
      return $oReturn;
}

   function getChildGIDS($gid) {
         global $database;
                  $query="SELECT g1.group_id, g1.name"
            ."\n FROM #__core_acl_aro_groups g1"
            ."\n LEFT JOIN #__core_acl_aro_groups g2 ON g2.lft >= g1.lft"
            ."\n WHERE g2.group_id =".$gid
            ."\n ORDER BY g1.name";
            $standardlist=array(-2,);
            if( $gid > 0) $standardlist[]=-1;
                  $array=array();
                  $database->setQuery( $query );
                  $array=$database->loadResultArray();
            $array=array_merge($array,$standardlist);
            return $array;
   }
   
      function getParentGIDS($gid) {
         global $database;
                  $query="SELECT g1.group_id, g1.name"
            ."\n FROM #__core_acl_aro_groups g1"
            ."\n LEFT JOIN #__core_acl_aro_groups g2 ON g2.lft <= g1.lft"
            ."\n WHERE g2.group_id =".$gid
            ."\n ORDER BY g1.name";
                  $array=array();
                  $database->setQuery( $query );
            $array=$database->loadResultArray();
            return $array;
   }
   
   function userGID($oID){
   global $database,$ueConfig;
   if($oID > 0) {
   $query = "SELECT gid FROM #__users WHERE id = '".$oID."'";
   $database->setQuery($query);
   $gid = $database->loadResult();
   return $gid;
   }
   else return 0;
}


   /**
   * Define the patTemplate function
   * @return patTemplate
   */
   function & createTemplate() {
      global $option, $mosConfig_absolute_path;
      require_once ($mosConfig_absolute_path.'/includes/patTemplate/patTemplate.php');

      $tmpl = & patFactory :: createTemplate($option, true, false);
      $tmpl->setRoot(dirname(__FILE__).'/tmpl');

      return $tmpl;
   }

   /*
   * Return 1 if the value is green
   */
   function green($green) {
      if ($green == "green") {
         return 1;
      } else {
         return 0;
      }
   }
   
      /*
   * Is the file or folder writeable 
   */
   function filedir_writeable($filedir) {
      if (is_writable($filedir)) {
         $color = "green";
      } else {
         $color = "red";
      }

      return $color;
   }

   function operator($n){
      $operator = "";
      $operator ="\n <select size=\"1\" name=\"operator[$n]\">";
      $operator .= "\n  <option value=\"\"></option>";      
      $operator .= "\n  <option value=\"AND\">"._CB_AS_OPERATORS_AND."</option>";
      $operator .= "\n  <option value=\"OR\">"._CB_AS_OPERATORS_OR."</option>";
      $operator .= "\n  <option value=\"AND (\">"._CB_AS_OPERATORS_AND." (</option>";
      $operator .= "\n  <option value=\"OR (\">"._CB_AS_OPERATORS_OR." (</option>";

      if ($n!=0){
         $operator .= "\n  <option value=\") AND (\">) "._CB_AS_OPERATORS_AND." (</option>";
         $operator .= "\n  <option value=\") OR (\">) "._CB_AS_OPERATORS_OR." (</option>";
         $operator .= "\n  <option value=\") AND \">) "._CB_AS_OPERATORS_AND."</option>";
         $operator .= "\n  <option value=\") OR \">) "._CB_AS_OPERATORS_OR."</option>";

      }
      $operator .= "\n</select>";      
      return $operator;
   }

   function operator2($nr,$cat){
      global $database;
      
      //First get the default value
      $query = "SELECT * FROM #__cb_search AS j"
         ."\n WHERE j.default=1 AND j.published=1 AND j.category=$cat";
      $database->setQuery($query);
      $rows = $database->loadObjectList();

      $operator2 ="\n <select size=\"1\" name=\"operator".$nr."_".$cat."\">";
      if ($cat == 2){
         $operator2 .= "\n <option value=\"AND\"></option>";
      } else {
         $operator2 .= "\n <option value=\"Like '%SEARCHWORD%'\"></option>";
      }
      
      for ($i = 0, $n = count($rows); $i < $n; $i ++) {
         $row = & $rows[$i];
         $operator2 .= "\n <option value=\"".$row->sql_code."\">".$row->name."</option>";
      }
                
      //Now we get the other values not set as defaults
      $query = "SELECT * FROM #__cb_search AS j"
         ."\n WHERE j.default=0 AND j.published=1 AND j.category=$cat";
      $database->setQuery($query);
      $rows = $database->loadObjectList();

      for ($i = 0, $n = count($rows); $i < $n; $i ++) {
         $row = & $rows[$i];
         $operator2 .= "\n <option value=\"".$row->sql_code."\">".$row->name."</option>";
      }
      $operator2 .= "\n</select>";
      
      return $operator2;
   }

   function gettable($whattable){
      global $database;
      $whattable2 = "";
      $query_custom = "SELECT f.* FROM #__comprofiler_fields f"
            . "\n WHERE f.published=1 AND f.profile = 1 "
            . "\n AND f.name = '".$whattable."'"
            . "\n ORDER BY f.ordering";

      $database->setQuery( $query_custom );
      $customfield = $database->loadObjectList();
      for ($s=0, $n=count( $customfield ); $s < $n; $s++) {
         $customfields = &$customfield[$s];
         $whattable2 = $customfields->table;
      }        

      if ( $whattable === "lastvisitDate" && $whattable2 === "#__comprofiler") {
         $whattable2 = "#__users";
      }
      if ( $whattable === "registerDate" && $whattable2 === "#__comprofiler") {
         $whattable2 = "#__users";
      }

      switch ($whattable2) {
         case '#__users':
            $table_syn = "u.";
            break;
         case '#__user':         
            $table_syn = "u.";
            break;
         case '#__comprofiler':        
            $table_syn = "ue.";
            break;
         default:       
            $table_syn = "ue.";
            break;
         }
      return  $table_syn;
      
   }

   function gettable2($whattable){
      global $database;
      $whattable2 = "";
      $query_custom = "SELECT f.* FROM #__comprofiler_fields f, #__cb_search_fields cb"
            . "\n WHERE f.fieldid=cb.fieldid"
            . "\n AND f.published=1 AND f.profile = 1 AND cb.search=1 "
            . "\n AND f.name = '".$whattable."'"
            . "\n ORDER BY cb.ordering, f.ordering";;

      $database->setQuery( $query_custom );
      $customfield = $database->loadObjectList();
      for ($s=0, $n=count( $customfield ); $s < $n; $s++) {
         $customfields = &$customfield[$s];
         $whattable2 = $customfields->table;
      }        
      
      if ( $whattable == "lastvisitDate" && $whattable2 == "#__comprofiler") {
         $whattable2 = "#__users";
      }
      if ( $whattable == "registerDate" && $whattable2 == "#__comprofiler") {
         $whattable2 = "#__users";
      }
      
      switch ( $whattable2 ) {
         case '#__users':
            $table_syn = "u.";
            break;
         case '#__user':         
            $table_syn = "u.";
            break;
         case '#__comprofiler':        
            $table_syn = "ue.";
            break;
         default:       
            $table_syn = "ue.";
            break;
         }
      return  $table_syn;
   }
  
   
   function getcolumndata(){
   global $database,$my,$ueConfig,$_POST,$_REQUEST;
   
   $database->setQuery("SELECT listid, title FROM #__comprofiler_lists WHERE published=1 AND useraccessgroupid IN (".implode(',',cb_as::getChildGIDS(cb_as::userGID($uid))).") ORDER BY ordering");
   $plists = $database->loadObjectList();
   //print $database->getQuery();
   $lists = array();
   $publishedlists = array();

   for ($i=0, $n=count( $plists ); $i < $n; $i++) {
      $plist =& $plists[$i];
         $publishedlists[] = mosHTML::makeOption( $plist->listid, getLangDefinition($plist->title) );
   }

   if(!isset($_POST['listid']) && !isset($_REQUEST['listid'])) {
      $database->setQuery( "SELECT listid FROM #__comprofiler_lists "
      . "\n WHERE `default`=1 AND published=1" );
      $listid = $database->loadresult();
   } else {
      if(isset($_POST['listid'])) $listid = cbGetEscaped($_POST['listid']);
      else $listid = cbGetEscaped($_REQUEST['listid']);
   }
   if(!$listid > 0) {
      echo _UE_NOLISTFOUND;
      return;
   }
   if (count($plists)>1) {
      $lists['plists'] = mosHTML::selectList( $publishedlists, 'listid', 'class="inputbox" size="1" onchange="this.form.submit();"', 'value', 'text', $listid );
   } else {
      $lists['plists'] = "&nbsp;";
   }
   
   $database->setQuery( "SELECT l.* FROM #__comprofiler_lists l"
   . "\n WHERE l.listid='$listid' AND l.published=1" );
   $row = $database->loadObjectList();
   
   if (!allowAccess( $row[0]->useraccessgroupid,'RECURSE', cb_as::userGID($uid))) {
      echo _UE_NOT_AUTHORIZED;
      return;
   }
   
   
   $col=$row[0]->col1fields;
   $col=explode('|*|',$col);
   $lfields="";   
   for ($i=0, $n=count( $col ); $i < $n; $i++) {
      if($i==0) $lfields .= "<td valign='top'>\n";
      else $lfields .= "<br/>\n";         
      if($col[$i]!='' && $col[$i]!=null) {
         $database->setQuery( "SELECT f.name, f.title, f.type "
            . "\nFROM #__comprofiler_fields AS f"
            . "\nWHERE f.published = 1 AND f.fieldid=".$col[$i]);
         $cfield = $database->loadObjectList();
         $cfield = $cfield[0];
         if($row[0]->col1captions==1)  $oTitle =  str_replace("'","\\'",getLangDefinition($cfield->title)).": ";
         else $oTitle='';
         $lfields .=  " \".getFieldValue('".$cfield->type."',\$user->".$cfield->name.",\$user,'".$oTitle."').\"";
      }
   }
   $lfields .= "</td>\n";
   if($row[0]->col2enabled) {
      $col=$row[0]->col2fields;
      $col=explode('|*|',$col);  
      for ($i=0, $n=count( $col ); $i < $n; $i++) {
         if($i==0) $lfields .= "<td valign='top'>\n";
         else $lfields .= "<br/>\n";
         if($col[$i]!='' && $col[$i]!=null) {
            $database->setQuery( "SELECT f.name, f.title, f.type "
               . "\nFROM #__comprofiler_fields AS f"
               . "\nWHERE f.published = 1 AND f.fieldid=".$col[$i]);
            $cfield = $database->loadObjectList();
            $cfield = $cfield[0];
            if($row[0]->col2captions==1) $oTitle =  str_replace("'","\\'",getLangDefinition($cfield->title)).": ";
            else $oTitle='';
            $lfields .=  " \".getFieldValue('".$cfield->type."',\$user->".$cfield->name.",\$user,'".$oTitle."').\"";
         }
      }
      $lfields .= "</td>\n";
   }
   if($row[0]->col3enabled) {
      $col=$row[0]->col3fields;
      $col=explode('|*|',$col);  
      for ($i=0, $n=count( $col ); $i < $n; $i++) {
         if($i==0) $lfields .= "<td valign='top'>\n";
         else $lfields .= "<br/>\n";
         $database->setQuery( "SELECT f.name, f.title, f.type "
            . "\nFROM #__comprofiler_fields AS f"
            . "\nWHERE f.published = 1 AND f.fieldid=".$col[$i]);
         $cfield = $database->loadObjectList();
         $cfield = $cfield[0];
         if($row[0]->col3captions==1)  $oTitle =  str_replace("'","\\'",getLangDefinition($cfield->title)).": ";
         else $oTitle='';
         $lfields .=  " \".getFieldValue('".$cfield->type."',\$user->".$cfield->name.",\$user,'".$oTitle."').\"";
      }
      $lfields .= "</td>\n";
   }
   if($row[0]->col4enabled) {
      $col=$row[0]->col4fields;
      $col=explode('|*|',$col);  
      for ($i=0, $n=count( $col ); $i < $n; $i++) {
         if($i==0) $lfields .= "<td valign='top'>\n";
         else $lfields .= "<br/>\n";
         if($col[$i]!='' && $col[$i]!=null) {
            $database->setQuery( "SELECT f.name, f.title, f.type "
               . "\nFROM #__comprofiler_fields AS f"
               . "\nWHERE f.published = 1 AND f.fieldid=".$col[$i]);
            $cfield = $database->loadObjectList();
            $cfield = $cfield[0];
            if($row[0]->col4captions==1)  $oTitle =  str_replace("'","\\'",getLangDefinition($cfield->title)).": ";
            else $oTitle='';
            $lfields .=  " \".getFieldValue('".$cfield->type."',\$user->".$cfield->name.",\$user,'".$oTitle."').\"";
         }     

      }
      $lfields .= "</td>\n";
   }
   return $row[0];

   }

   /**
   * Constructor
   * Includes files needed for displaying calendar for date fields
   * @param int user interface: 1=Front End 2=Admin
   */
   function cbCalendars($ui) {
      global $mosConfig_live_site, $mainframe, $mosConfig_lang, $ueConfig;
      //$this->ui=$ui;
      $dFind=array("d","m","y","Y");
      $dReplace=array("%d","%m","%y","%Y");
      //$this->dateFormat = str_replace($dFind, $dReplace, $ueConfig['date_format']);

      $UElanguagePath=$mainframe->getCfg( 'absolute_path' ).'/components/com_comprofiler/plugin/language';
      if (file_exists($UElanguagePath.'/'.$mosConfig_lang.'/calendar-locals.js')) {
         $calendarLangFile = $mosConfig_live_site.'/components/com_comprofiler/plugin/language/'.$mosConfig_lang.'/calendar-locals.js';
      } else {
         $calendarLangFile = $mosConfig_live_site.'/components/com_comprofiler/plugin/language/default_language/calendar-locals.js';
      }
      
            
      return '<link rel="stylesheet" type="text/css" media="all" href="'.selectTemplate($ui).'calendar.css" title="win2k-cold-1" />'
      ."\n".'<script type="text/javascript" src="'. $mosConfig_live_site . '/components/com_comprofiler/js/calendar.js"></script>'."\n"
      .'<script type="text/javascript" src="'. $calendarLangFile . '"></script>'."\n"     // language
      .'<script type="text/javascript" src="'. $mosConfig_live_site . '/components/com_comprofiler/js/calendar-setup.js"></script>'."\n";
   }

   /**
   * echos a calendar field
   * @param string the field name
   * @param string the field label
   * @param boolean true if field is required
   * @param string the existing value (in Y-mm-dd SQL format)
   * @param boolean read-only field
   */
   function cbAddCalendar($oName, $oLabel, $oReq, $oValue="", $oReadOnly=false) {
      global $ueConfig;
      if ($oValue=='0000-00-00 00:00:00' || $oValue=='0000-00-00') $oValue="";
      else $oValue=dateConverter($oValue,'Y-m-d','Y-m-d');
      $return = '<input class="inputbox" mosReq="'.$oReq.'" mosLabel="'.getLangDefinition($oLabel).'" type="text" name="' . $oName .'" id="' . $oName . '" value="' . $oValue . '" />'."\n";
      
      $dateFormat = '%Y-%m-%d';
   
      if (!$oReadOnly) $return .= "<script type=\"text/javascript\">\n"
      . "Calendar.setup({"
      . 'inputField : "'.$oName.'",'   // id of the input field
      . 'ifFormat   : "'.$dateFormat.'",' // format of the input field
      . 'showsTime  : false,'          // will display a time selector
      . 'singleClick: true'            // single-click mode
      . "});\n"
      . "</script>\n";
      return $return;
   }

//Taken from the joomla API
   /**
   * Generates an HTML radio list
   * @param array An array of objects
   * @param string The value of the HTML name attribute
   * @param string Additional HTML attributes for the <select> tag
   * @param mixed The key that is selected
   * @param string The name of the object variable for the option value
   * @param string The name of the object variable for the option text
   * @param string Can set the radio field to hidden
   * @returns string HTML for the select list
   */
   function radioList( &$arr, $tag_name, $tag_attribs, $selected=null, $hidden='radio', $key='value', $text='text' ) {
      reset( $arr );
      $html = "";
      for ($i=0, $n=count( $arr ); $i < $n; $i++ ) {
         $k = $arr[$i]->$key;
         $t = $arr[$i]->$text;
         $id = ( isset($arr[$i]->id) ? @$arr[$i]->id : null);

         $extra = '';
         $extra .= $id ? " id=\"" . $arr[$i]->id . "\"" : '';
         if (is_array( $selected )) {
            foreach ($selected as $obj) {
               $k2 = $obj->$key;
               if ($k == $k2) {
                  $extra .= " selected=\"selected\"";
                  break;
               }
            }
         } else {
            $extra .= ($k == $selected ? " checked=\"checked\"" : '');
         }
         $html .= "\n\t<input type=\"$hidden\" name=\"$tag_name\" id=\"$tag_name$k\" value=\"".$k."\"$extra $tag_attribs />";
         if ($hidden == "radio"){
            $html .= "\n\t<label for=\"$tag_name$k\">$t</label>";
         }
      }
      $html .= "\n";
      return $html;
   }


/**
 * gets Itemid of CB profile, or by default of homepage
 * @param boolean TRUE if should return "&amp:Itemid...." instead of "&Itemid..." (with FALSE as default)
 * @return string "&Itemid=xxx"
 */
function getCBprofileItemid( $htmlspecialchars= false ) {
   global $_CB__Cache_ProfileItemid, $database;

   if (!$_CB__Cache_ProfileItemid) {
      if(!isset($_REQUEST['Itemid'])) {
         $database->setQuery("SELECT id FROM #__menu WHERE link = 'index.php?option=com_cb_search' AND published=1");
         $Itemid = $database->loadResult();
      } else {
         $Itemid = intval($_REQUEST['Itemid']);
      }
      if (!$Itemid) {
         /** Nope, just use the homepage then. */
         $query = "SELECT id"
         . "\n FROM #__menu"
         . "\n WHERE menutype = 'mainmenu'"
         . "\n AND published = 1"
         . "\n ORDER BY parent, ordering"
         . "\n LIMIT 1"
         ;
         $database->setQuery( $query );
         $Itemid = $database->loadResult();
      }
      $_CB__Cache_ProfileItemid = $Itemid;
   }
   if ($_CB__Cache_ProfileItemid) {
      return ($htmlspecialchars ? "&amp;" : "&")."Itemid=".$_CB__Cache_ProfileItemid;
   } else {
      return null;
   }
}


/**
* Page navigation support functions
*/

/**
* Writes the html links for pages, eg, previous 1 2 3 ... x next
* @param int The record number to start dislpaying from
* @param int Number of rows to display per page
* @param int Total number of rows
* @param string base url (without SEF): sefRelToAbs done inside this function
* @param mixed string/array : string: search parameter added as &$prefix.search=... if NOT NULL ; array: each added as $prefix.&key=$val
* @param string prefix on the &limitstart and &search URL items
*/

function writePagesLinks($limitstart, $limit, $total,$ue_base_url,$search=null,$prefix="") {
   global $mosConfig_sef;
   $ret="";

   if ($mosConfig_sef){
      $sefchar = ",";
      $sefchar2 = "";
      $sefchar3 = "/";
   } else {
      $sefchar = "=";
      $sefchar2 = "&amp;";
      $sefchar3 = "";
   }

   if (is_array($search)) {
      $search_str = "";
      foreach ($search as $k => $v) {
         if ($v && $k!="limitstart")  $search_str .= $sefchar2.urlencode($prefix.$k)."=".urlencode($v);
      }
   } else {
      $search_str = (($search) ? $sefchar2.urlencode($prefix).$sefchar3."search".$sefchar.urlencode($search) : "");
   }

   $limstart_str = "".urlencode($prefix).$sefchar2."limitstart".$sefchar;
   $pages_in_list = 9;                // set how many pages you want displayed in the menu (not including first&last, and ev. ... repl by single page number.
   $displayed_pages = $pages_in_list;
   $total_pages = ceil( $total / $limit );
   $this_page = ceil( ($limitstart+1) / $limit );
   // $start_loop = (floor(($this_page-1)/$displayed_pages))*$displayed_pages+1;
   $start_loop = $this_page-floor($displayed_pages/2); if ($start_loop < 1) $start_loop = 1; if ($start_loop == 3) $start_loop = 2;    //BB
   if ($start_loop + $displayed_pages - 1 < $total_pages-2) {
      $stop_loop = $start_loop + $displayed_pages - 1;
   } else {
      $stop_loop = $total_pages;
   }

   if ($this_page > 1) {
      $page = ($this_page - 2) * $limit;
      $ret .= "\n<a class=\"pagenav\" href=\"".sefRelToAbs($ue_base_url.$limstart_str."0".$search_str)."\" title=\"" . _UE_FIRST_PAGE . "\">&lt;&lt; " . _UE_FIRST_PAGE . "</a>";
      $ret .= "\n<a class=\"pagenav\" href=\"".sefRelToAbs($ue_base_url.$limstart_str.$page.$search_str)."\" title=\"" . _UE_PREV_PAGE . "\">&lt; " . _UE_PREV_PAGE . "</a>";
      if ($start_loop > 1) $ret .= "\n<a class=\"pagenav\" href=\"".sefRelToAbs($ue_base_url.$limstart_str."0".$search_str)."\" title=\"" . _UE_FIRST_PAGE . "\"><strong>1</strong></a>";
      if ($start_loop > 2) $ret .= "\n<span class=\"pagenav\"> <strong>...</strong> </span>";
   } else {
         $ret .= '<span class="pagenav">&lt;&lt; '. _UE_FIRST_PAGE .'</span> ';
         $ret .= '<span class="pagenav">&lt; '. _UE_PREV_PAGE .'</span> ';
      }

   for ($i=$start_loop; $i <= $stop_loop; $i++) {
      $page = ($i - 1) * $limit;
      if ($i == $this_page) {
         $ret .= "\n <span class=\"pagenav\">[".$i."]</span> ";
      } else {
         $ret .= "\n<a class=\"pagenav\" href=\"".sefRelToAbs($ue_base_url.$limstart_str.$page.$search_str)."\"><strong>$i</strong></a>";
      }
   }

   if ($this_page < $total_pages) {
      $page = $this_page * $limit;
      $end_page = ($total_pages-1) * $limit;
      if ($stop_loop < $total_pages-1) $ret .= "\n<span class=\"pagenav\"> <strong>...</strong> </span>";
      if ($stop_loop < $total_pages) $ret .= "\n<a class=\"pagenav\" href=\"".sefRelToAbs($ue_base_url.$limstart_str.$end_page.$search_str)."\" title=\"" . _UE_END_PAGE . "\"><strong>".$total_pages."</strong></a>";
      $ret .= "\n<a class=\"pagenav\" href=\"".sefRelToAbs($ue_base_url.$limstart_str.$page.$search_str)."\" title=\"" . _UE_NEXT_PAGE . "\">" . _UE_NEXT_PAGE . " &gt;</a>";
      $ret .= "\n<a class=\"pagenav\" href=\"".sefRelToAbs($ue_base_url.$limstart_str.$end_page.$search_str)."\" title=\"" . _UE_END_PAGE . "\">" . _UE_END_PAGE . " &gt;&gt;</a>";
   } else {
      $ret .= '<span class="pagenav">'. _UE_NEXT_PAGE .' &gt;</span> ';
      $ret .= '<span class="pagenav">'. _UE_END_PAGE .' &gt;&gt;</span>';
   }
   return $ret;
}


function correct_search($search_sql){
   $pattern[0] = "+";
   $pattern[1] = "%28";
   $pattern[2] = "%27";
   $pattern[3] = "%25";
   $pattern[4] = "%29";
   $replacement[0] = " ";
   $replacement[1] = "(";
   $replacement[2] = "'";
   $replacement[3] = "%";
   $replacement[4] = ")";
   $fieldvalue = str_replace($pattern, $replacement, $search_sql );
   return $fieldvalue;
}

//End of class
} 
